#include <string.h>
#include <alloc.h>
#include <stdarg.h>
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <ctype.h>
#include <process.h>

#define VGA_INPUT_STATUS_1 0x3DA
#define VGA_VSYNC_MASK 0x08

void WaitForVsync(void){
	while(inp(VGA_INPUT_STATUS_1) & VGA_VSYNC_MASK);
	while(!(inp(VGA_INPUT_STATUS_1) & VGA_VSYNC_MASK));
}


enum {
GAMESTART,
SHOWLOGO,
LOGO,
SHOWMAINMENU,
MAINMENU,
SHOWMAINMAP,
MAINMAP
};

//Function Declarations
void ShowLogoScreen();
void ShowMainMenu();
void ShowIntroduction();
void ShowCredits();

int MainMenuKeyStatus=0; //shows where the cursor is in the mainmenu


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- main -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//hmm...main?
int main()
{
	textbackground(0);
	clrscr();  //clear the screen first thing

	int Status;  //the message mapper
//	Status=GAMESTART; //starts you off at the beginning of the game
	char keytemp;  //temp varaible that holds temporary key presses
	int Quit; //makes the program exit after the current function is over
	Quit=0;

	Status=GAMESTART;

	while(Quit==0)
	{

			_setcursortype(_NORMALCURSOR);  //set it to a normal cursor for the main menu

			switch(Status)
			{
			case GAMESTART:
				ShowLogoScreen();
				Status=LOGO;
				break;
			case LOGO:
				ShowMainMenu();
				Status=MAINMENU;
				break;
			case MAINMENU:
				while(!kbhit())  //wait until the user presses a key
				{
				}
				keytemp=getch();  //get the key pressed into a variable
				keytemp=toupper(keytemp); //turn the key pressed into uppercase
				switch(keytemp)
				{
				case 27:  //handles the ESC key
					Quit=1;
					break;
				case 13:  //handles the enter k ey
					switch(MainMenuKeyStatus)
					{
					case 2: //This is the Show Intro button
						ShowIntroduction();
						ShowMainMenu();
						break;
					case 3: //This is the Show Credits button
						ShowCredits();
						ShowMainMenu();
						break;
					case 4: //this is the Exit Game Button
						Quit=1;  //quits the game promptly :)
						break;
					}
					break;
				case 0:  //trap the extended character set (for arrow keys)
					keytemp=getch();
					switch(keytemp)
					{
						case 'P':  //down arrow key
							if(MainMenuKeyStatus<4)
							{
								MainMenuKeyStatus=MainMenuKeyStatus++;
								gotoxy(28,12+MainMenuKeyStatus);
							}
							break;
						case 'H': //up arrow key
							if(MainMenuKeyStatus>0)
							{
								MainMenuKeyStatus=MainMenuKeyStatus--;
								gotoxy(28,12+MainMenuKeyStatus);
							}
							break;
					break;
				}
			}
		};
	};
return(0);
};


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowLogoScreen -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//shows my logo screen
void ShowLogoScreen()
{

_setcursortype(_NOCURSOR);

	int temp;  //our little temp variable

	clrscr();  //clears the screen

	textcolor(7);
	for(temp=1;temp<45;temp++)
	{
		gotoxy(1,5);
		cprintf("                                                                              ");
		gotoxy(temp,5);
		WaitForVsync();
		cprintf("F i n a l   F a n t a s y   Z e r o\r\n\n");
		delay(20);
	}

	textcolor(2);
	gotoxy(1,1);     //Displays the version number
	cprintf("v.06 Pre-Alpha");

	textcolor(8);
	for(temp=1;temp<63;temp++)
	{
		gotoxy(1,7);
		cprintf("                                                                              ");
		gotoxy(temp,7);
		WaitForVsync();
		cprintf("Text Mode Version\r\n");
		delay(20);
	}

	textcolor(9);
	for(temp=1;temp<55;temp++)
	{
		gotoxy(1,8);
		cprintf("                                                                              ");
		gotoxy(temp,8);
		WaitForVsync();
		cprintf("Created by: Justin Heiner\r\n");
		delay(20);
	}

	textcolor(12);
	gotoxy(31,20);
	cprintf("Press Any Key");
	while(!kbhit())  //wait until the user presses a key
	{
	}
	getch(); //throw away what the user pressed

};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowMainMenu -=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//Displays the main menu
void ShowMainMenu()
{
_setcursortype(_NOCURSOR);
clrscr();

textcolor(3);
cprintf("\r\n");
cprintf("      ____|_)             |   ____|           |                    __  /\r\n");
cprintf("      |     | __ \\   _` | |   |    _` | __ \\  __| _` |  __| |   |     /\r\n");
cprintf("      __|   | | | | (   | |   __| (   | | | | |  (   |\\__ \\ |   |    /\r\n");
cprintf("     _|    _|_| |_|\\__,_|_|  _|  \\__,_|_| |_|\\__\\__,_|____/\\__, |  ____|\r\n");
cprintf("                                                           ____/\r\n");
textcolor(4);
cprintf("                                                            /$\r\n");
cprintf("                                                                  by: ArdDisk\r\n");


gotoxy(27,12);
textcolor(9);
cprintf("+-=N");
textcolor(7);
cprintf("ew Game=----------+");

gotoxy(27,13);
textcolor(9);
cprintf("+-=L");
textcolor(7);
cprintf("oad Game=---------+");

gotoxy(27,14);
textcolor(9);
cprintf("+-=S");
textcolor(7);
cprintf("how Introduction=-+");

gotoxy(27,15);
textcolor(9);
cprintf("+-=S");
textcolor(7);
cprintf("how Credits=------+");

gotoxy(27,16);
textcolor(9);
cprintf("+-=E");
textcolor(7);
cprintf("xit Game=---------+");

gotoxy(28,12); //positions the cursor over the first menu selection


}

//-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowCredits -=-=-=-=-=-=-=-=-=-=-=-=-=-
//shows who made this wonderful game :)
void ShowCredits()
{
_setcursortype(_NOCURSOR);

clrscr();
textcolor(7);
gotoxy(34,2);
cprintf("CREDITS");
gotoxy(21,10);
textcolor(3);
cprintf("Programming:");
textcolor(2);
cprintf("          MeRWiN");
gotoxy(21,11);
textcolor(3);
cprintf("  ASCII Art:");
textcolor(2);
cprintf("          HardDisk");
gotoxy(21,12);
textcolor(3);
cprintf("      Sound:");
textcolor(2);
cprintf("          What sound?");
gotoxy(16,22);
textcolor(9);
cprintf("Based on the Final Fantasy games by SquareSoft");

while(!kbhit())  //wait until the user presses a key
{
}
getch(); //throw away what the user pressed
MainMenuKeyStatus=0;

}

//-=-=-=-=-=-=-=-=-=-=-=-=-=- ShowIntroduction -=-=-=-=-=-=-=-=-=-=-=-=-=-
//displays the introduction story
void ShowIntroduction()
{
_setcursortype(_NOCURSOR);

int StopDaLooping=0;
char *str1;
char intro[20][80];
textbackground(1);
clrscr();
gotoxy(1,2);

str1="         In 1927, the world had been turned into a wasteland due to a\r\n";
strcpy(&intro[0][0],str1);
str1="       massive world war greater than any other war that had ever been\r\n";
strcpy(&intro[1][0],str1);
str1="      experienced in the past.  All of the nations of the world had been\r\n";
strcpy(&intro[2][0],str1);
str1="         devistated and in dire need of food and supplies to rebuild\r\n";
strcpy(&intro[3][0],str1);
str1="            and attempt to restart their countries and their lives.\r\n\n";
strcpy(&intro[4][0],str1);
str1="          Germany, the only country to come out of this war unscathed,\r\n";
strcpy(&intro[5][0],str1);
str1="         built huge factories around the world and created a worldwide\r\n";
strcpy(&intro[6][0],str1);
str1="          military which was led by a man by the name of Adolf Hitler.\r\n\n";
strcpy(&intro[7][0],str1);
str1="         Hitler set up more than 500 concentration camps in the former\r\n";
strcpy(&intro[8][0],str1);
str1="           United States alone.  Hitler's rule continued to increase\r\n";
strcpy(&intro[9][0],str1);
str1="               until he and his troops dominated the entire world.\r\n\n";
strcpy(&intro[10][0],str1);
str1="        Three hundred years have passed since Hitler took control over\r\n";
strcpy(&intro[11][0],str1);
str1="         the world.  Cities had been rebuilt, technology was at a peak,\r\n";
strcpy(&intro[12][0],str1);
str1="                and life was, for the most part, very pleasant.\r\n\n";
strcpy(&intro[13][0],str1);
str1="        Four young men, hearing stories of the past freedom, decided to\r\n";
strcpy(&intro[14][0],str1);
str1="         create a revolt throughout the world so as to bring the world\r\n";
strcpy(&intro[15][0],str1);
str1="                      back to its former and divided self.\r\n\n";
strcpy(&intro[16][0],str1);
str1="                         And here the story begins...\r\n";
strcpy(&intro[17][0],str1);

	delay(140);
	clrscr();
	WaitForVsync();
	gotoxy(1,2);
	for(int temp=0;temp<=17 && StopDaLooping==0;temp++)
	{
		for(int temp2=0;temp2<160 && StopDaLooping==0;temp2+=20)
		{
			int temp4=wherex();
			int temp3=wherey();
			if(!kbhit())  //if the user hasn't hit a key, do all the rest of this stuff.
			{
				delay(temp2);
				printf("%s",&intro[temp][0]);
				delay(temp2);
				gotoxy(temp4,temp3);
				delline();
			}
			else
				StopDaLooping=1;  //if the user presses a key, it exits out of the loop prematurely (sp?)
		}

		printf("%s",&intro[temp][0]);
	}


while(!kbhit())  //wait until the user presses a key
{
}
getch(); //throw away what the user pressed
textbackground(0);
clrscr();
MainMenuKeyStatus=0;
}
